## zeal 0.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

project(Zeal VERSION 0.4.0)

# Project information.
if(APPLE)
    set(PROJECT_OUTPUT_NAME "Zeal")
else()
    set(PROJECT_OUTPUT_NAME "zeal")
endif()

set(PROJECT_COMPANY_NAME "ZealDocs")
string(TIMESTAMP PROJECT_COPYRIGHT "© 2015-%Y Oleg Shparber" UTC)
set(PROJECT_DESCRIPTION "A simple documentation browser.")
set(PROJECT_URL "https://zealdocs.org")

add_subdirectory(assets)
add_subdirectory(src)

=== src/app/CMakeLists.txt ===
# TODO: Move zeal.qrc one level up to rely on CMAKE_AUTORCC.
find_package(Qt5Core REQUIRED)
qt5_add_resources(App_RESOURCES resources/zeal.qrc)

if(APPLE)
    list(APPEND App_RESOURCES resources/zeal.icns)
elseif(WIN32)
    configure_file(versioninfo.rc.in ${CMAKE_CURRENT_BINARY_DIR}/versioninfo.rc)
    list(APPEND App_RESOURCES ${CMAKE_CURRENT_BINARY_DIR}/versioninfo.rc)
endif()

add_executable(App WIN32
    main.cpp
    ${App_RESOURCES}
)

target_link_libraries(App Core Util)

find_package(Qt5 COMPONENTS Concurrent Widgets REQUIRED)
target_link_libraries(App Qt5::Concurrent Qt5::Widgets)

set_target_properties(App PROPERTIES
    OUTPUT_NAME ${PROJECT_OUTPUT_NAME}
    RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
)

if(APPLE)
    set_target_properties(App PROPERTIES
        MACOSX_BUNDLE TRUE
        MACOSX_BUNDLE_BUNDLE_NAME ${PROJECT_NAME}
        MACOSX_BUNDLE_GUI_IDENTIFIER "org.zealdocs.zeal"
        MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
        MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION}
        MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}"
        MACOSX_BUNDLE_ICON_FILE "zeal.icns"
        MACOSX_BUNDLE_COPYRIGHT ${PROJECT_COPYRIGHT}
        RESOURCE "resources/zeal.icns"
    )
elseif(UNIX)
    find_package(ECM REQUIRED NO_MODULE)
    set(CMAKE_MODULE_PATH ${ECM_KDE_MODULE_DIR})
    include(KDEInstallDirs)

    install(TARGETS App DESTINATION ${KDE_INSTALL_BINDIR})
endif()

=== src/libs/core/CMakeLists.txt ===
add_library(Core
    application.cpp
    extractor.cpp
    localserver.cpp
    networkaccessmanager.cpp
    settings.cpp
)

target_link_libraries(Core Registry Ui)

find_package(Qt5 COMPONENTS Network WebKit Widgets REQUIRED)
target_link_libraries(Core Qt5::Network Qt5::WebKit Qt5::Widgets)

find_package(LibArchive REQUIRED)
include_directories(${LibArchive_INCLUDE_DIRS})
target_link_libraries(Core ${LibArchive_LIBRARIES})

=== src/libs/ui/CMakeLists.txt ===
add_subdirectory(qxtglobalshortcut)

list(APPEND Widgets_SOURCES
    widgets/searchablewebview.cpp
    widgets/searchedit.cpp
    widgets/shortcutedit.cpp
    widgets/toolbarframe.cpp
    widgets/webview.cpp
)

set(Ui_FORMS
    aboutdialog.ui
    docsetsdialog.ui
    mainwindow.ui
    settingsdialog.ui
)

add_library(Ui
    aboutdialog.cpp
    docsetlistitemdelegate.cpp
    docsetsdialog.cpp
    mainwindow.cpp
    progressitemdelegate.cpp
    searchitemdelegate.cpp
    settingsdialog.cpp
    ${Widgets_SOURCES}
    ${Ui_FORMS} # For Qt Creator.
)

target_link_libraries(Ui QxtGlobalShortcut Registry)

find_package(Qt5 COMPONENTS WebKitWidgets REQUIRED)
target_link_libraries(Ui Qt5::WebKitWidgets)

## zeal 0.1.1

=== debian/changelog ===
zeal (1:0.1.1-2) unstable; urgency=medium

  * Add missing dependency libqt5sql5-sqlite.
    Thanks to Sammy Tahtah (Closes: #795561)
  * Set ZEAL_VERSION.
    Thanks to Sammy Tahtah (Closes: #795564)

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Mon, 17 Aug 2015 00:14:11 +0800

zeal (1:0.1.1-1) unstable; urgency=medium

  * New upstream release
  * Remove unused libquazip-qt5 patch
  * Update copyright

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Thu, 23 Jul 2015 21:23:15 +0800

zeal (20141123-1) unstable; urgency=low

  * Initial release (Closes: #747219)

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Thu, 19 Feb 2015 22:18:16 +0800

=== debian/control ===
Source: zeal
Section: utils
Priority: optional
Maintainer: ChangZhuo Chen (陳昌倬) <czchen@gmail.com>
Build-Depends: debhelper (>= 9),
               libappindicator-dev,
               libarchive-dev,
               libqt5webkit5-dev,
               qt5-qmake,
               qtbase5-dev (>= 5.2.0),
               qtbase5-private-dev,
Standards-Version: 3.9.6
Homepage: http://zealdocs.org/
Vcs-Git: git://anonscm.debian.org/collab-maint/zeal.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/zeal.git

Package: zeal
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libqt5sql5-sqlite,
Description: Simple offline API documentation browser
 Zeal is a simple offline API documentation browser inspired by Dash (OS X
 app), available for Linux and Windows.
 .
  * Quickly search documentation using Alt+Space (or customised) hotkey to
    display Zeal from any place in your workspace.
  * Search in multiple sets of documentation at once.
  * Don't be dependent on your internet connection.
  * Integrate Zeal with Emacs, Sublime Text, or Vim.

Package: zeal-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends},
         zeal (= ${binary:Version}),
Description: Debug symbols for zeal
 Zeal is a simple offline API documentation browser inspired by Dash (OS X
 app), available for Linux and Windows.
 .
  * Quickly search documentation using Alt+Space (or customised) hotkey to
    display Zeal from any place in your workspace.
  * Search in multiple sets of documentation at once.
  * Don't be dependent on your internet connection.
  * Integrate Zeal with Emacs, Sublime Text, or Vim.
 .
 This package contains debug symbols for zeal.

=== debian/rules ===
#!/usr/bin/make -f
#DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS := hardening=+all
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
export QT_SELECT := qt5
export ZEAL_VERSION := $(shell dpkg-parsechangelog --show-field Version | perl -pe 's/\d+:(.*)-\d+/$$1/p')

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ --buildsystem=qmake --dbg-package=zeal-dbg --fail-missing

override_dh_auto_configure:
	# FIXME: Cannot build this project with "-nocache", but don't know how
	# to disable it.
	qmake -makefile \
		"QMAKE_CFLAGS_RELEASE=${CFLAGS}" \
		"QMAKE_CFLAGS_DEBUG=${CFLAGS}" \
		"QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}" \
		"QMAKE_CXXFLAGS_DEBUG=${CXXFLAGS}" \
		"QMAKE_LFLAGS_RELEASE=${LDFLAGS}" \
		"QMAKE_LFLAGS_DEBUG=${LDFLAGS}" \
		QMAKE_STRIP=: PREFIX=/usr

## zeal 0.2.1

=== debian/changelog ===
zeal (1:0.2.1-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Thu, 26 Nov 2015 20:06:48 +0800

zeal (1:0.2.0-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 17 Nov 2015 12:15:18 +0800

zeal (1:0.1.1+20151029-2) unstable; urgency=medium

  * Adjust priority to extra for libxcb-keysyms1.
  * Update Vcs-* fields.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 03 Nov 2015 13:05:42 +0800

zeal (1:0.1.1+20151029-1) unstable; urgency=medium

  [ Yao-Po Wang ]
  * Add -D_FORTIFY_SOURCE=2 into CXXFLAGS to avoid the dpkg-buildflags-missing
    warning in blhc. (Closes: #795843)

  [ ChangZhuo Chen (陳昌倬) ]
  * Use upstream git snapshot. (Closes: #802871)
  * Update copyright.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 01 Nov 2015 20:01:40 +0800

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,26 @@
 Source: zeal
+Maintainer: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
 Section: utils
-Priority: optional
-Maintainer: ChangZhuo Chen (陳昌倬) <czchen@gmail.com>
+Priority: extra
 Build-Depends: debhelper (>= 9),
                libappindicator-dev,
                libarchive-dev,
                libqt5webkit5-dev,
+               libqt5x11extras5-dev,
+               libxcb-keysyms1-dev,
                qt5-qmake,
-               qtbase5-dev (>= 5.2.0),
+               qtbase5-dev,
                qtbase5-private-dev,
 Standards-Version: 3.9.6
+Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/zeal.git/?h=debian/sid
+Vcs-Git: git://anonscm.debian.org/collab-maint/zeal.git -b debian/sid
 Homepage: http://zealdocs.org/
-Vcs-Git: git://anonscm.debian.org/collab-maint/zeal.git
-Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/zeal.git
 
 Package: zeal
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-         libqt5sql5-sqlite,
+         libqt5sql5-sqlite
 Description: Simple offline API documentation browser
  Zeal is a simple offline API documentation browser inspired by Dash (OS X
  app), available for Linux and Windows.
@@ -30,11 +32,11 @@
   * Integrate Zeal with Emacs, Sublime Text, or Vim.
 
 Package: zeal-dbg
+Architecture: any
 Section: debug
 Priority: extra
-Architecture: any
 Depends: ${misc:Depends},
-         zeal (= ${binary:Version}),
+         zeal (= ${binary:Version})
 Description: Debug symbols for zeal
  Zeal is a simple offline API documentation browser inspired by Dash (OS X
  app), available for Linux and Windows.

=== debian/rules ===
--- 
+++ 
@@ -18,8 +18,8 @@
 	qmake -makefile \
 		"QMAKE_CFLAGS_RELEASE=${CFLAGS}" \
 		"QMAKE_CFLAGS_DEBUG=${CFLAGS}" \
-		"QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}" \
-		"QMAKE_CXXFLAGS_DEBUG=${CXXFLAGS}" \
+		"QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS} ${CPPFLAGS}" \
+		"QMAKE_CXXFLAGS_DEBUG=${CXXFLAGS} ${CPPFLAGS}" \
 		"QMAKE_LFLAGS_RELEASE=${LDFLAGS}" \
 		"QMAKE_LFLAGS_DEBUG=${LDFLAGS}" \
 		QMAKE_STRIP=: PREFIX=/usr

=== debian/watch ===
version=3
https://github.com/jkozera/zeal/releases .*/v(\d\S*).tar.gz

## zeal 0.3.1

=== debian/changelog ===
zeal (1:0.3.1-1) unstable; urgency=medium

  * New upstream release.
  * Update watch file.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Fri, 14 Oct 2016 22:35:40 +0800

zeal (1:0.2.1-4) unstable; urgency=medium

  * Use asciidoc instead of ronn to generate manpage.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 07 Aug 2016 01:03:02 +0800

zeal (1:0.2.1-3) unstable; urgency=medium

  * Use UTC time to make package reproducible.
    Thanks to Chris Lamb (Closes: 828164)

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 26 Jun 2016 00:18:55 +0800

zeal (1:0.2.1-2) unstable; urgency=medium

  * Bump Standards-Version to 3.9.8.
  * Remove zeal-dbg in favor of zeal-dbgsym.
  * Update Vcs-* fields.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 15 Jun 2016 09:31:02 +0800

=== debian/control ===
Source: zeal
Maintainer: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
Section: utils
Priority: extra
Build-Depends: debhelper (>= 9.20151219),
               asciidoc,
               libappindicator-dev,
               libarchive-dev,
               libqt5webkit5-dev,
               libqt5x11extras5-dev,
               libxcb-keysyms1-dev,
               qt5-qmake,
               qtbase5-dev,
               qtbase5-private-dev,
               xmlto,
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/zeal.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/zeal.git
Homepage: http://zealdocs.org/

Package: zeal
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libqt5sql5-sqlite
Description: Simple offline API documentation browser
 Zeal is a simple offline API documentation browser inspired by Dash (OS X
 app), available for Linux and Windows.
 .
  * Quickly search documentation using Alt+Space (or customised) hotkey to
    display Zeal from any place in your workspace.
  * Search in multiple sets of documentation at once.
  * Don't be dependent on your internet connection.
  * Integrate Zeal with Emacs, Sublime Text, or Vim.

=== debian/rules ===
--- 
+++ 
@@ -10,9 +10,14 @@
 include /usr/share/dpkg/default.mk
 
 %:
-	dh $@ --buildsystem=qmake --dbg-package=zeal-dbg --fail-missing
+	dh $@ --buildsystem=qmake --fail-missing
+
+override_dh_strip:
+	dh_strip --ddeb-migration='zeal-dbg (<< 1:0.2.1-1~)'
 
 override_dh_auto_configure:
+	cat debian/*manpages | sed 's/$$/.txt/p' | xargs -n 1 a2x --doctype manpage --format manpage
+
 	# FIXME: Cannot build this project with "-nocache", but don't know how
 	# to disable it.
 	qmake -makefile \

=== debian/watch ===
version=3
https://github.com/zealdocs/zeal/releases .*/v(\d\S*).tar.gz

## zeal 0.4.0

=== debian/changelog ===
zeal (1:0.4.0-2) unstable; urgency=medium

  * Add missing Build-Depends libsqlite3-dev (Closes: #876606).

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 07 Oct 2017 15:07:40 +0800

zeal (1:0.4.0-1) unstable; urgency=medium

  * New upstream release (Closes: 875614).
  * Bump Standards-Version to 4.1.0.
    * Change priority to optional.
    * Use https in Format field in d/copyright.
  * Bump compat to 10.
  * Don't set ZEAL_VERSION in d/rule since it is set by qmake/common.pri.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 16 Sep 2017 17:23:13 +0800

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,21 @@
 Source: zeal
 Maintainer: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
 Section: utils
-Priority: extra
-Build-Depends: debhelper (>= 9.20151219),
+Priority: optional
+Build-Depends: debhelper (>= 10),
                asciidoc,
+               cmake (>= 3.5.1),
                libappindicator-dev,
                libarchive-dev,
                libqt5webkit5-dev,
                libqt5x11extras5-dev,
+               libsqlite3-dev,
                libxcb-keysyms1-dev,
                qt5-qmake,
-               qtbase5-dev,
+               qtbase5-dev (>= 5.5.1),
                qtbase5-private-dev,
                xmlto,
-Standards-Version: 3.9.8
+Standards-Version: 4.1.0
 Vcs-Browser: https://anonscm.debian.org/git/collab-maint/zeal.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/zeal.git
 Homepage: http://zealdocs.org/

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,6 @@
 export DEB_BUILD_MAINT_OPTIONS := hardening=+all
 export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
 export QT_SELECT := qt5
-export ZEAL_VERSION := $(shell dpkg-parsechangelog --show-field Version | perl -pe 's/\d+:(.*)-\d+/$$1/p')
 
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/default.mk

## zeal 0.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.5.1)
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
 
-project(Zeal VERSION 0.4.0)
+project(Zeal VERSION 0.6.0)
 
 # Project information.
 if(APPLE)
@@ -15,5 +15,7 @@
 set(PROJECT_DESCRIPTION "A simple documentation browser.")
 set(PROJECT_URL "https://zealdocs.org")
 
+set(QT_MINIMUM_VERSION 5.5.1)
+
 add_subdirectory(assets)
 add_subdirectory(src)

=== assets/CMakeLists.txt ===
if(UNIX AND NOT APPLE)
    find_package(ECM REQUIRED NO_MODULE)
    set(CMAKE_MODULE_PATH ${ECM_KDE_MODULE_DIR})
    include(KDEInstallDirs)

    foreach(_i 16 24 32 64 128)
        install(FILES "freedesktop/appicons/${_i}/zeal.png"
            DESTINATION "${KDE_INSTALL_ICONDIR}/hicolor/${_i}x${_i}/apps"
            # TODO: Use `RENAME zeal.png` and get rid of subdirectories.
        )
    endforeach()

    # TODO: Generate via zeal.desktop.in.
    install(FILES "freedesktop/zeal.desktop"
        DESTINATION ${KDE_INSTALL_APPDIR}
    )
endif()

=== src/libs/ui/qxtglobalshortcut/CMakeLists.txt ===
list(APPEND QxtGlobalShortcut_SOURCES
    qxtglobalshortcut.cpp
)

if(APPLE)
    list(APPEND QxtGlobalShortcut_SOURCES
        qxtglobalshortcut_mac.cpp
    )
elseif(UNIX)
    find_package(X11)
    if(X11_FOUND)
        list(APPEND QxtGlobalShortcut_SOURCES
            qxtglobalshortcut_x11.cpp
        )
    endif()
elseif(WIN32)
    list(APPEND QxtGlobalShortcut_SOURCES
        qxtglobalshortcut_win.cpp
    )
endif()

add_library(QxtGlobalShortcut ${QxtGlobalShortcut_SOURCES})

find_package(Qt5Gui REQUIRED)
target_link_libraries(QxtGlobalShortcut Qt5::Gui)

if(APPLE)
    find_library(CARBON_LIBRARY Carbon)
    target_link_libraries(QxtGlobalShortcut ${CARBON_LIBRARY})
elseif(UNIX AND X11_FOUND)
    target_link_libraries(QxtGlobalShortcut ${X11_LIBRARIES})

    find_package(Qt5 COMPONENTS X11Extras REQUIRED)
    target_link_libraries(QxtGlobalShortcut Qt5::X11Extras)

    find_package(ECM REQUIRED NO_MODULE)
    set(CMAKE_MODULE_PATH ${ECM_FIND_MODULE_DIR})

    find_package(XCB COMPONENTS XCB KEYSYMS REQUIRED)
    target_link_libraries(QxtGlobalShortcut XCB::XCB XCB::KEYSYMS)
endif()

=== debian/changelog ===
zeal (1:0.6.0-2) unstable; urgency=medium

  * Update Build-Depends.
    * Add missing extra-cmake-modules (Closes: #890917).
    * Use asciidoc-base instead of asciidoc.
    * Remove qt5-qmake.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 21 Feb 2018 15:57:55 +0800

zeal (1:0.6.0-1) unstable; urgency=medium

  * New upstream release (Closes: #801125).
  * Bump Standards-Version to 4.1.3.
  * Bump compat to 11.
  * Update Vcs-* fields to salsa.debian.org.
  * Disable ad by default (Closes: #878874).

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 20 Feb 2018 22:29:08 +0800

=== debian/control ===
--- 
+++ 
@@ -2,22 +2,22 @@
 Maintainer: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
 Section: utils
 Priority: optional
-Build-Depends: debhelper (>= 10),
-               asciidoc,
+Build-Depends: debhelper (>= 11),
+               asciidoc-base,
                cmake (>= 3.5.1),
+               extra-cmake-modules,
                libappindicator-dev,
                libarchive-dev,
                libqt5webkit5-dev,
                libqt5x11extras5-dev,
                libsqlite3-dev,
                libxcb-keysyms1-dev,
-               qt5-qmake,
                qtbase5-dev (>= 5.5.1),
                qtbase5-private-dev,
                xmlto,
-Standards-Version: 4.1.0
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/zeal.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/zeal.git
+Standards-Version: 4.1.3
+Vcs-Browser: https://salsa.debian.org/debian/zeal
+Vcs-Git: https://salsa.debian.org/debian/zeal.git
 Homepage: http://zealdocs.org/
 
 Package: zeal

## zeal 0.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,8 @@
 cmake_minimum_required(VERSION 3.5.1)
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
 
-project(Zeal VERSION 0.6.0)
+project(Zeal VERSION 0.6.1)
+set(RELEASE_DATE 2018-09-28)
 
 # Project information.
 if(APPLE)
@@ -11,7 +12,7 @@
 endif()
 
 set(PROJECT_COMPANY_NAME "ZealDocs")
-string(TIMESTAMP PROJECT_COPYRIGHT "© 2015-%Y Oleg Shparber" UTC)
+set(PROJECT_COPYRIGHT "© 2015-2018 Oleg Shparber")
 set(PROJECT_DESCRIPTION "A simple documentation browser.")
 set(PROJECT_URL "https://zealdocs.org")

=== src/CMakeLists.txt ===
# Only C++11
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Find includes in corresponding build directories.
set(CMAKE_INCLUDE_CURRENT_DIR ON)

## Build options
option(ZEAL_PORTABLE_BUILD "Build portable version")
if(ZEAL_PORTABLE_BUILD)
    add_definitions(-DPORTABLE_BUILD)
endif()

## Macro
add_definitions(-DZEAL_VERSION="${Zeal_VERSION}")

# QString options
add_definitions(-DQT_USE_QSTRINGBUILDER)
add_definitions(-DQT_RESTRICTED_CAST_FROM_ASCII)
add_definitions(-DQT_NO_CAST_TO_ASCII)
add_definitions(-DQT_NO_URL_CAST_FROM_STRING)

## Handle moc, uic, and rcc files.
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

include_directories(libs)
add_subdirectory(libs)

add_subdirectory(app)

=== assets/freedesktop/CMakeLists.txt ===
if(UNIX AND NOT APPLE)
    find_package(ECM 1.0.0 REQUIRED NO_MODULE)
    set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
    include(ECMInstallIcons)
    include(KDEInstallDirs)

    ecm_install_icons(ICONS "16-apps-zeal.png"
                            "24-apps-zeal.png"
                            "32-apps-zeal.png"
                            "64-apps-zeal.png"
                            "128-apps-zeal.png"
                      DESTINATION ${KDE_INSTALL_ICONDIR}
    )

    configure_file( 
        org.zealdocs.Zeal.appdata.xml.in 
        org.zealdocs.Zeal.appdata.xml
    )

    install(FILES ${CMAKE_BINARY_DIR}/assets/freedesktop/org.zealdocs.Zeal.appdata.xml
            DESTINATION ${KDE_INSTALL_METAINFODIR}
    )

    install(FILES "org.zealdocs.Zeal.desktop"
            DESTINATION ${KDE_INSTALL_APPDIR}
    )
endif()

=== src/app/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,8 @@
 # TODO: Move zeal.qrc one level up to rely on CMAKE_AUTORCC.
 find_package(Qt5Core REQUIRED)
 qt5_add_resources(App_RESOURCES resources/zeal.qrc)
+# Silence CMP0071.
+set_property(SOURCE qrc_zeal.cpp PROPERTY SKIP_AUTOGEN ON)
 
 if(APPLE)
     list(APPEND App_RESOURCES resources/zeal.icns)
@@ -16,8 +18,12 @@
 
 target_link_libraries(App Core Util)
 
-find_package(Qt5 COMPONENTS Concurrent Widgets REQUIRED)
-target_link_libraries(App Qt5::Concurrent Qt5::Widgets)
+find_package(Qt5 COMPONENTS Widgets REQUIRED)
+if (Qt5Widgets_VERSION VERSION_LESS QT_MINIMUM_VERSION)
+    message(FATAL_ERROR "Qt version >= ${QT_MINIMUM_VERSION} is required.")
+endif()
+
+target_link_libraries(App Qt5::Widgets)
 
 set_target_properties(App PROPERTIES
     OUTPUT_NAME ${PROJECT_OUTPUT_NAME}

=== src/libs/CMakeLists.txt ===
add_subdirectory(core)
add_subdirectory(registry)
add_subdirectory(ui)
add_subdirectory(util)

=== src/libs/registry/CMakeLists.txt ===
add_library(Registry
    cancellationtoken.h
    docset.cpp
    docsetmetadata.cpp
    docsetregistry.cpp
    listmodel.cpp
    searchmodel.cpp
    searchquery.cpp
    searchresult.h # Only for Qt Creator to see it.
)

find_package(Qt5 COMPONENTS Concurrent Gui Network REQUIRED)
target_link_libraries(Registry Util Qt5::Concurrent Qt5::Gui Qt5::Network)

=== src/libs/ui/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,12 @@
 add_subdirectory(qxtglobalshortcut)
 
 list(APPEND Widgets_SOURCES
-    widgets/searchablewebview.cpp
     widgets/searchedit.cpp
+    widgets/searchtoolbar.cpp
     widgets/shortcutedit.cpp
     widgets/toolbarframe.cpp
     widgets/webview.cpp
+    widgets/webviewtab.cpp
 )
 
 set(Ui_FORMS
@@ -23,6 +24,7 @@
     progressitemdelegate.cpp
     searchitemdelegate.cpp
     settingsdialog.cpp
+    webbridge.cpp
     ${Widgets_SOURCES}
     ${Ui_FORMS} # For Qt Creator.
 )

=== src/libs/util/CMakeLists.txt ===
# Nothing to moc here, so avoid empty build units.
set(CMAKE_AUTOMOC OFF)

add_library(Util
    plist.cpp
    sqlitedatabase.cpp
    version.cpp
)

find_package(Qt5Core REQUIRED)
target_link_libraries(Util Qt5::Core)

find_package(SQLite REQUIRED)
include_directories(${SQLite_INCLUDE_DIR})
target_link_libraries(Util ${SQLite_LIBRARY})

# TODO: Do not export SQLite headers.
target_include_directories(Util PUBLIC ${SQLite_INCLUDE_DIR})

=== debian/changelog ===
zeal (1:0.6.1-1.2) unstable; urgency=medium

  [ Kentaro Hayashi ]
  * Non-maintainer upload.
  * Remove needless libappindicator-dev from Build-Depends.
    Closes: #956782.

 -- Stephen Kitt <skitt@debian.org>  Sun, 25 Apr 2021 13:33:43 +0200

zeal (1:0.6.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream patch to fix build with Qt 5.15 (closes: #972177).

 -- Dmitry Shachnev <mitya57@debian.org>  Sun, 25 Oct 2020 13:29:32 +0300

zeal (1:0.6.1-1) unstable; urgency=medium

  * New upstream release.
  * Change Section to doc.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 31 Oct 2018 14:44:09 +0800

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: zeal
 Maintainer: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
-Section: utils
+Section: doc
 Priority: optional
 Build-Depends: debhelper (>= 11),
                asciidoc-base,
                cmake (>= 3.5.1),
                extra-cmake-modules,
-               libappindicator-dev,
                libarchive-dev,
                libqt5webkit5-dev,
                libqt5x11extras5-dev,

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS := hardening=+all
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
export QT_SELECT := qt5

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ --fail-missing

override_dh_strip:
	dh_strip --ddeb-migration='zeal-dbg (<< 1:0.2.1-1~)'

override_dh_auto_configure:
	cat debian/*manpages | sed 's/$$/.txt/p' | xargs -n 1 a2x --doctype manpage --format manpage
	dh_auto_configure

## zeal 0.6.1%2Brebuild

=== src/libs/core/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,8 @@
 add_library(Core
     application.cpp
+    applicationsingleton.cpp
     extractor.cpp
-    localserver.cpp
+    filemanager.cpp
     networkaccessmanager.cpp
     settings.cpp
 )

=== debian/changelog ===
zeal (1:0.6.1+rebuild-1+eagle) unstable; urgency=medium

  * update

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 26 Jan 2021 17:21:41 +0800

## zeal 0.6.1+git20220714+6fee23

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16.3)

# CMake options.
set(CMAKE_ERROR_DEPRECATED TRUE)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

project(Zeal VERSION 0.6.2)

# Set to TRUE for a tagged release.
# NOTE: Don't forget to add a new release entry in the AppStream metadata!
set(RELEASE_VERSION FALSE)

# Project information.
if(APPLE)
    set(PROJECT_OUTPUT_NAME "Zeal")
else()
    set(PROJECT_OUTPUT_NAME "zeal")
endif()

set(PROJECT_COMPANY_NAME "ZealDocs")
set(PROJECT_COPYRIGHT "© 2013-2020 Oleg Shparber and other contributors")
set(PROJECT_DESCRIPTION "A simple documentation browser.")
set(PROJECT_URL "https://zealdocs.org")

set(QT_MINIMUM_VERSION 5.9.5)

# Determine version for dev builds.
if(NOT RELEASE_VERSION)
    message(NOTICE "Building unreleased code. Proceed at your own risk!")

    # TODO: Add support for metadata passed from env, e.g. aur, appimage, etc.
    include(GetVersionFromGit)
    if(Zeal_GIT_VERSION_SHA)
        # Extra check in case we forgot to bump version in project() directive.
        if(NOT PROJECT_VERSION_PATCH EQUAL Zeal_GIT_VERSION_PATCH_NEXT)
            message(FATAL_ERROR "Incorrect patch version! Forgot to bump?")
        endif()

        set(ZEAL_VERSION_SUFFIX "-dev.${Zeal_GIT_VERSION_AHEAD}+${Zeal_GIT_VERSION_SHA}")
    else()
        set(ZEAL_VERSION_SUFFIX "-dev")
    endif()
endif()

set(ZEAL_VERSION_FULL "${Zeal_VERSION}${ZEAL_VERSION_SUFFIX}")

# For development builds insert an extra release in the AppStream metadata.
if(NOT RELEASE_VERSION)
    string(TIMESTAMP ZEAL_APPSTREAM_DEV_RELEASE "\n    <release date=\"%Y-%m-%d\" version=\"${ZEAL_VERSION_FULL}\" type=\"development\" />")
endif()

# A custom target to print the full version.
# Usage: cmake --build build --target zeal_version
add_custom_target(zeal_version
    COMMAND ${CMAKE_COMMAND} -E echo "Zeal version: ${ZEAL_VERSION_FULL}"
    VERBATIM
)

add_subdirectory(assets)
add_subdirectory(src)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,4 @@
-# Only C++11
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 # Find includes in corresponding build directories.
@@ -11,8 +10,8 @@
     add_definitions(-DPORTABLE_BUILD)
 endif()
 
-## Macro
-add_definitions(-DZEAL_VERSION="${Zeal_VERSION}")
+## Macros.
+add_definitions(-DZEAL_VERSION="${ZEAL_VERSION_FULL}")
 
 # QString options
 add_definitions(-DQT_USE_QSTRINGBUILDER)

=== assets/freedesktop/CMakeLists.txt ===
--- 
+++ 
@@ -12,16 +12,16 @@
                       DESTINATION ${KDE_INSTALL_ICONDIR}
     )
 
-    configure_file( 
-        org.zealdocs.Zeal.appdata.xml.in 
-        org.zealdocs.Zeal.appdata.xml
+    configure_file(
+        org.zealdocs.zeal.appdata.xml.in
+        org.zealdocs.zeal.appdata.xml
     )
 
-    install(FILES ${CMAKE_BINARY_DIR}/assets/freedesktop/org.zealdocs.Zeal.appdata.xml
+    install(FILES ${CMAKE_BINARY_DIR}/assets/freedesktop/org.zealdocs.zeal.appdata.xml
             DESTINATION ${KDE_INSTALL_METAINFODIR}
     )
 
-    install(FILES "org.zealdocs.Zeal.desktop"
+    install(FILES "org.zealdocs.zeal.desktop"
             DESTINATION ${KDE_INSTALL_APPDIR}
     )
 endif()

=== src/app/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,3 @@
-# TODO: Move zeal.qrc one level up to rely on CMAKE_AUTORCC.
-find_package(Qt5Core REQUIRED)
-qt5_add_resources(App_RESOURCES resources/zeal.qrc)
-# Silence CMP0071.
-set_property(SOURCE qrc_zeal.cpp PROPERTY SKIP_AUTOGEN ON)
-
 if(APPLE)
     list(APPEND App_RESOURCES resources/zeal.icns)
 elseif(WIN32)
@@ -13,6 +7,7 @@
 
 add_executable(App WIN32
     main.cpp
+    zeal.qrc
     ${App_RESOURCES}
 )
 
@@ -49,3 +44,30 @@
 
     install(TARGETS App DESTINATION ${KDE_INSTALL_BINDIR})
 endif()
+
+#
+# CPack Configuration.
+#
+set(CPACK_PACKAGE_NAME ${PROJECT_NAME})
+set(CPACK_PACKAGE_VENDOR ${PROJECT_COMPANY_NAME})
+set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
+
+set(CPACK_VERBATIM_VARIABLES YES)
+
+# Set options for the source package.
+# Usage: cmake --build build --target package_source
+set(CPACK_SOURCE_GENERATOR "TGZ;TXZ;ZIP")
+set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_OUTPUT_NAME}-${ZEAL_VERSION_FULL}")
+set(CPACK_SOURCE_IGNORE_FILES
+    # Directories.
+    ".git/"
+    ".github/"
+    ".vscode/"
+    "build/"
+    # Files.
+    ".editorconfig"
+    ".gitattributes"
+    ".gitignore"
+)
+
+include(CPack)

=== src/libs/browser/CMakeLists.txt ===
add_library(Browser STATIC
    searchtoolbar.cpp
    settings.cpp
    urlrequestinterceptor.cpp
    webbridge.cpp
    webcontrol.cpp
    webpage.cpp
    webview.cpp
)

target_link_libraries(Browser)

find_package(Qt5 COMPONENTS WebEngineWidgets WebChannel REQUIRED)
target_link_libraries(Browser Qt5::WebEngineWidgets Qt5::WebChannel)

=== src/libs/core/CMakeLists.txt ===
add_library(Core STATIC
    application.cpp
    applicationsingleton.cpp
    extractor.cpp
    filemanager.cpp
    httpserver.cpp
    networkaccessmanager.cpp
    settings.cpp

    # Show headers without .cpp in Qt Creator.
    httplib.h
)

# Configure cpp-httplib.
add_definitions(-DCPPHTTPLIB_USE_POLL)

target_link_libraries(Core Registry Ui)

find_package(Qt5 COMPONENTS Network WebEngine Widgets REQUIRED)
target_link_libraries(Core Qt5::Network Qt5::WebEngine Qt5::Widgets)

find_package(LibArchive REQUIRED)
include_directories(${LibArchive_INCLUDE_DIRS})
target_link_libraries(Core ${LibArchive_LIBRARIES})

# Required by cpp-httplib.
if(NOT WIN32)
    set(THREADS_PREFER_PTHREAD_FLAG ON)
    find_package(Threads REQUIRED)
    target_link_libraries(Core Threads::Threads)
endif()

=== src/libs/registry/CMakeLists.txt ===
add_library(Registry STATIC
    docset.cpp
    docsetmetadata.cpp
    docsetregistry.cpp
    listmodel.cpp
    searchmodel.cpp
    searchquery.cpp

    # Show headers without .cpp in Qt Creator.
    cancellationtoken.h
    itemdatarole.h
    searchresult.h
)

find_package(Qt5 COMPONENTS Concurrent Gui Network REQUIRED)
target_link_libraries(Registry Util Qt5::Concurrent Qt5::Gui Qt5::Network)

=== src/libs/sidebar/CMakeLists.txt ===
add_library(Sidebar STATIC
    container.cpp
    proxyview.cpp
    view.cpp
    viewprovider.cpp
)

target_link_libraries(Sidebar)

find_package(Qt5 COMPONENTS Widgets REQUIRED)
target_link_libraries(Sidebar Qt5::Widgets)

=== src/libs/ui/CMakeLists.txt ===
add_subdirectory(qxtglobalshortcut)
add_subdirectory(widgets)

set(Ui_FORMS
    aboutdialog.ui
    docsetsdialog.ui
    mainwindow.ui
    settingsdialog.ui
)

add_library(Ui STATIC
    aboutdialog.cpp
    browsertab.cpp
    docsetlistitemdelegate.cpp
    docsetsdialog.cpp
    mainwindow.cpp
    searchitemdelegate.cpp
    searchsidebar.cpp
    settingsdialog.cpp
    sidebarviewprovider.cpp
    ${Ui_FORMS} # For Qt Creator.
)

target_link_libraries(Ui Browser Sidebar QxtGlobalShortcut Widgets Registry)

find_package(Qt5 COMPONENTS WebEngineWidgets REQUIRED)
target_link_libraries(Ui Qt5::WebEngineWidgets)

=== src/libs/util/CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,12 @@
 # Nothing to moc here, so avoid empty build units.
 set(CMAKE_AUTOMOC OFF)
 
-add_library(Util
+add_library(Util STATIC
     plist.cpp
     sqlitedatabase.cpp
-    version.cpp
+
+    # Show headers without .cpp in Qt Creator.
+    caseinsensitivemap.h
 )
 
 find_package(Qt5Core REQUIRED)

=== src/libs/ui/qxtglobalshortcut/CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
     )
 endif()
 
-add_library(QxtGlobalShortcut ${QxtGlobalShortcut_SOURCES})
+add_library(QxtGlobalShortcut STATIC ${QxtGlobalShortcut_SOURCES})
 
 find_package(Qt5Gui REQUIRED)
 target_link_libraries(QxtGlobalShortcut Qt5::Gui)

=== src/libs/ui/widgets/CMakeLists.txt ===
add_library(Widgets STATIC
    layouthelper.cpp
    searchedit.cpp
    shortcutedit.cpp
    toolbarframe.cpp
)

find_package(Qt5 COMPONENTS Widgets REQUIRED)
target_link_libraries(Widgets Qt5::Widgets)

=== debian/changelog ===
zeal (1:0.6.1+git20220714+6fee23-2) unstable; urgency=medium

  * Restrict to the Architectures where qtwebengine5 is available.

 -- Martin Quinson <mquinson@debian.org>  Wed, 10 Aug 2022 10:59:12 +0200

zeal (1:0.6.1+git20220714+6fee23-1) unstable; urgency=medium

  * Package the current git master branch.
  * d/p/0001-Disable-ad-by-default: Dropped, the setting was removed.
  * d/p/0002-Fix-compilation-error-with-Qt-5.15.patch: Dropped.

 -- Martin Quinson <mquinson@debian.org>  Fri, 15 Jul 2022 16:39:20 +0200

zeal (1:0.6.1-2) unstable; urgency=medium

  [ Konstantin Demin ]
  * Propose a patch that will be needed for next release:
    Build using system cpp-httplib.
  * d/control: bump debhelper to v13

  [ Martin Quinson ]
  * Add myself to the uploaders (Closes: #1014413).
  * d/watch: Update to v4 format
  * d/control: Bump Standards-version to 4.6.1 (no change needed)
  * d/rules: Drop '-Wl,--as-needed' (it's the default on bullseye)
  * d/p/disable-check-for-update: New patch to not check upstream
    for new versions (Closes: #910802)

 -- Martin Quinson <mquinson@debian.org>  Thu, 14 Jul 2022 18:08:26 +0200

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,31 @@
 Source: zeal
 Maintainer: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
+Uploaders: Martin Quinson <mquinson@debian.org>
 Section: doc
 Priority: optional
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 13),
                asciidoc-base,
                cmake (>= 3.5.1),
                extra-cmake-modules,
                libarchive-dev,
+               libcpp-httplib-dev,
                libqt5webkit5-dev,
                libqt5x11extras5-dev,
                libsqlite3-dev,
                libxcb-keysyms1-dev,
                qtbase5-dev (>= 5.5.1),
                qtbase5-private-dev,
+               qtwebengine5-dev,
                xmlto,
-Standards-Version: 4.1.3
+Standards-Version: 4.6.1
+Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/zeal
 Vcs-Git: https://salsa.debian.org/debian/zeal.git
-Homepage: http://zealdocs.org/
+Homepage: https://zealdocs.org/
 
 Package: zeal
-Architecture: any
+Architecture: amd64 arm64 armhf i386 mips64el mipsel
+# (qtwebengine5 is not available on the other arch)
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          libqt5sql5-sqlite

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS := hardening=+all
export QT_SELECT := qt5

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@

execute_before_dh_auto_configure:
	cat debian/*manpages | sed 's/$$/.txt/p' | xargs -n 1 a2x --doctype manpage --format manpage
